Page MenuHomePhabricator

[mlir][gpu] Allow gpu.launch_func to be async.
ClosedPublic

Authored by csigg on Oct 13 2020, 8:56 AM.

Diff Detail

Event Timeline

csigg created this revision.Oct 13 2020, 8:56 AM
csigg requested review of this revision.Oct 13 2020, 8:56 AM
csigg updated this revision to Diff 297887.Oct 13 2020, 9:26 AM

Update documentation.

csigg updated this revision to Diff 297888.Oct 13 2020, 9:29 AM

Rebase.

The semantics of async or not is *very* different from most analysis point of view. It isn't clear to me that having a single op for modeling both instead of a new operation is the right tradeoff here: I'm afraid it is too error prone.

The semantics of async or not is *very* different from most analysis point of view. It isn't clear to me that having a single op for modeling both instead of a new operation is the right tradeoff here: I'm afraid it is too error prone.

I generally agree with this, but I'm also struggling to come up with any optimizations we would actually want to do on gpu.launch_func.

herhut requested changes to this revision.Oct 21 2020, 7:10 AM

Can you remove the printing of the extra attribute?

mlir/test/Conversion/GPUCommon/lower-launch-func-to-gpu-runtime-calls.mlir
24 ↗(On Diff #297888)

It is sad that this gets printed. I assume there currently is no way around this with assemblyFormat. Does this roundtrip when reparsed? I assume operand_segment_sizes just gets overwritten with the constructed attribute.

This revision now requires changes to proceed.Oct 21 2020, 7:10 AM
csigg updated this revision to Diff 299723.Oct 21 2020, 9:32 AM

Switch two test instances of gpu.launch_func from standard form to custom form. Rebase.

csigg added inline comments.Oct 21 2020, 9:34 AM
mlir/test/Conversion/GPUCommon/lower-launch-func-to-gpu-runtime-calls.mlir
24 ↗(On Diff #297888)

That was the standard format. Changed to custom format now.

csigg updated this revision to Diff 299755.Oct 21 2020, 11:10 AM

Update vulkan-runner tests.

csigg updated this revision to Diff 299869.Oct 21 2020, 10:52 PM

Splitting 'switch to custom gpu.launch_func format' into separate change.

mravishankar resigned from this revision.Oct 24 2020, 3:43 PM
herhut accepted this revision.Oct 29 2020, 8:53 AM
This revision is now accepted and ready to land.Oct 29 2020, 8:53 AM
This revision was automatically updated to reflect the committed changes.

I reverted because it seems a test was crashing here: https://buildkite.com/mlir/mlir-core/builds/8962#330b9ea4-53a6-4ec9-8d10-5b40b806aa41

(I hope I got the right patch)